'DATAPORT Program: Note that any line starting with a quote mark is a comment
'Start by declaring variables and types
dim as integer x,y,red1,red2=512,blue1,blue2=512,grn1,grn2=512,i,k,sw,ad1,ad2,ad3,sum,buffer,port,vgrid=24
dim as string mk,xunits,mode
dim as double begin, elapsed, dur
dim as integer x1=50, seconds, m, flag=0
dim as single v1,v2,v3,timeunits,msec=30
'these variable used for the thermistor temperature calculation
dim as single t1,t2,t3

'A subroutine is used for precision timing
declare sub delay(t1 as double)

'specify graphic screen that is 800 pixels wide by 600 pixels high with sharp text
screen 19
'note that 0 is the black foreground and 15 is the white background
'color map: black(0),blue(1),green(2),red(4),brown(6),yellow(14),white(15)
Color 0, 15
'clear the graphic screen
Cls
'hide the mouse while the program is running
setmouse 400,300,0,0

'create a welcome screen for the program specifics, (locate function is units of rows down, spaces over)
locate 3,10:color 0,15: print "SCIENCE BAY, INC.  DATAPORT PROGRAM  All rights reserved. 2013"
locate 5,10:color 0,15: print "This program was written to record data for general purpose applications"
locate 6,10:color 0,15: print "Visit http://www.sciencebay.net for more information.           "
locate 7,10:color 0,15: print "Compiled using the Free Basic Language, Visit http://www.freebasic.net "
locate 8,10:color 0,15: print "Data collected from a Picaxe-08M2 using a Serial Port (N,8,1) 38400 baud "
locate 9,10:color 0,15: print "Power must be applied to DATALOG module before continuing! "


'*********************************COM PORT SELECT and TEST**********************************************
'*******************************************************************************************************

Do
	'loop to determine the com port number to use for communication
	'input command expects input from user at the keyboard, Ports 1-10 allowed
	locate 10,10:color 0,15:
	print "                              "
	locate 10,10:color 0,15:
	input "Enter COM Port Number (1-10): ", port
loop until port=1 or port=2 or port=3 or port=4 or port=5 or port=6 or port=7 or port=8 or port=9 or port=10

'loop to open the com port identified by the user
locate 11,10:color 0,15:print "                          "
locate 11,10:color 0,15:print "Testing for the COM Port. "

'Open COM port and if an error is detected, print message and end the program.
if port = 1 then open com "COM1:38400,n,8,1,cs0,cd0,ds0,rs" as #2
if port = 2 then open com "COM2:38400,n,8,1,cs0,cd0,ds0,rs" as #2
if port = 3 then open com "COM3:38400,n,8,1,cs0,cd0,ds0,rs" as #2
if port = 4 then open com "COM4:38400,n,8,1,cs0,cd0,ds0,rs" as #2
if port = 5 then open com "COM5:38400,n,8,1,cs0,cd0,ds0,rs" as #2
if port = 6 then open com "COM6:38400,n,8,1,cs0,cd0,ds0,rs" as #2
if port = 7 then open com "COM7:38400,n,8,1,cs0,cd0,ds0,rs" as #2
if port = 8 then open com "COM8:38400,n,8,1,cs0,cd0,ds0,rs" as #2
if port = 9 then open com "COM9:38400,n,8,1,cs0,cd0,ds0,rs" as #2
if port = 10 then open com "COM10:38400,n,8,1,cs0,cd0,ds0,rs" as #2

if err = 0 then 
	locate 12,10:color 0,15: print "                                            "
	locate 12,10:color 0,15: print "Serial Port is present on computer. Now Testing Data Transfer... "
else
	locate 12,10:color 4,15: print "                                                   " 
	locate 12,10:color 4,15: print "WARNING:SERIAL PORT IS NOT PRESENT: PROGRAM ENDING "
	sleep 3000
	'exit the program by going to jump1
	goto jump1
end if

for m=1 to 50
	'this loop tests the serial port speed using standard 50 msec time delay
	'this loop clears the serial port buffer of any bytes that may be present
		while loc(2) > 0
		input #2, buffer
		wend
	'transmit the 'X' character to the picaxe to initiate a data report
	print #2, chr(88)
	sleep 50

	'first test: anything in the buffer? If not, set the exit flag
	if loc(2)=0 then flag=1
	if flag=1 then goto jump4

	input #2, mk,seconds,sw,ad1,ad2,ad3,sum

	'second test: is the checksum correct? If not, set the exit flag
	if (sum<>sw+ad1+ad2+ad3) then flag=1
	if flag=1 then goto jump4
next m

jump4:
if flag = 1 then
	locate 13,10:color 4,15: print "                                        " 
	locate 13,10:color 4,15: print "Data Transfer failed: DATAPORT Module not found: Check Power & Port # "
	sleep 5000
	goto jump1
else
	locate 13,10:color 0,15: print "                        " 
	locate 13,10:color 0,15: print "Serial Port Speed is OK "	
end if


'************************************End of COM Port Select and Test*********************************
'****************************************************************************************************

'loop for user to enter the data logging duration in minutes
Do
	locate 14,10:color 0,15: print "                                              "
	locate 14,10:color 0,15:
	input "Enter datalog duration (1, 60 or 1440 minutes): ", dur
loop until dur=1 or dur=60 or dur=1440

'default setting first, then other settings for special cases
if dur=1 then xunits="Seconds"
if dur=60 then xunits="Minutes"
if dur=1440 then xunits="Hours"

'loop for user to enter the data logging mode: Voltage(V) or Temperature(T)
Do
	locate 15,10:color 0,15: print "                                              "
	locate 15,10:color 0,15:
	input "Enter data acquisition mode: V for Voltage, or T for Temperature: ", mode
loop until mode="V" or mode="T"

locate 16,10:color 0,15: print "                                " 
locate 16,10:color 0,15: print "Data logging is now starting... "
sleep 1000
cls

'draw horizontal grid lines for the graph (always the same)
for y=50 to 550 step 50
	line (40,y)-(760,y),7
next y

'draw vertical grid lines for the graph
if dur=1440 then vgrid=30 'creates hours divisions
if dur=60 then vgrid=60   'creates minutes divisions
if dur=1 then vgrid=60    'creates seconds divisions
for x=40 to 760 step vgrid
line (x,50)-(x,550),7
next x

'format horizontal x axis along bottom, print default first, then special cases
if dur=1 then locate 36, 5: color 0,15: print "0       5      10      15     20      25     30      35     40      45     50      55     60"
if dur=60 then locate 36, 5: color 0,15: print "0       5      10      15     20      25     30      35     40      45     50      55     60"
if dur=1440 then locate 36, 5: color 0,15: print "0       2      4       6      8       10     12      14     16      18     20      22     24"


if mode="V" then
	'for the y axis along the left hand side edge (Volts)
	locate 4,2: color 0,15: print "5.0"
	locate 10,2: color 0,15: print "4.0"
	locate 16,2: color 0,15: print "3.0"
	locate 23,2: color 0,15: print "2.0"
	locate 29,2: color 0,15: print "1.0"
	locate 35,2: color 0,15: print "0.0"
	locate 19,3: color 0,15: print "V"
end if

if mode="T" then
	'for the y axis along the right hand side edge (Deg F)
	'this a special case for measuring temperature
	'change location 2 to 97 (below) to place on RHS
	locate 4,2: color 0,15: print "225"
	locate 10,2: color 0,15: print "175"
	locate 16,2: color 0,15: print "125"
	locate 23,2: color 0,15: print "75"
	locate 29,2: color 0,15: print "25"
	locate 35,2: color 0,15: print "-25"
	locate 20,2: color 0,15: print "F"
end if

'print marker for the switch status
'prevent an automatic carriage return on last line by using a semicolon
locate 37,2: color 0,15: print "SW";


sleep 1000

'routine to identify and open the data file, a maximum of 100 data files are allowed
for k=1 to 100
	open "DATA" & string(3 - len(str(k)), "0") & k & ".CSV" for input as #1
	if err=0 then close #1
	if err>0 then 
	open "DATA" & string(3 - len(str(k)), "0") & k & ".CSV" for binary as #1
	goto jump2
	end if
next k
jump2:


'print header information at top of the display graph
locate 1,2: color 0,15: print "DATALOGGER by Science Bay "
locate 1,30: color 0,15: print "Hit ESC key to EXIT "
'Now that the name of the data file and bitmap file are known, we can display them on the screen
locate 1,53: color 0,15: print "Data File: " & "DATA" & string(3 - len(str(k)), "0") & k & ".CSV"
locate 1,77: color 0,15: print "Image File: " & "BMP" & string(3 - len(str(k)), "0") & k & ".BMP"

sleep 2000



'Write headings in the comma delimited data file (csv file)
write #1, "Time","Seconds","Marker","Switch","AD1","AD2","AD3","Checksum","V1","V2","V3", "T1","T2","T3"

'This loop clears the serial port buffer of any bytes that may be present
while loc(2) > 0
input #2, buffer
wend

'***********************************************************************************************
'************************START OF MAIN DATA ACQUISITION LOOP************************************
'***********************************************************************************************

'take the 720 data sample points to fill the graph, note offset for blank space on rhs
for i=40 to 760

	'This loop clears the serial port buffer of stray data bytes
	while loc(2) > 0
	input #2, buffer
	wend

	'use the first reading as the start of the data set
	if i=40 then begin = timer
	'transmit the 'X' character to the picaxe to initiate a data report
	print #2, chr(88)
	'put delay here to allow the serial port buffer to fill
	'this delay is necessary,and is shorter than 1 adc cycle so the computer clock can regulate rate
	'at end of the loop using a check based on the timer function
	'for reference, total theoretical delay between readings is equal to (dur*60/720)
	'testing showed that 30 msec is practical lower limit
	sleep 50

	'do a few maintenace tasks before checking for data...
	'calculate elapsed time from start for this set of readings
	elapsed=timer-begin
	'force first time to always be exactly zero
	if i=40 then elapsed = 0

	'make sure there is data waiting to be read...if not, print error message and exit
	if loc(2)=0 then
		locate 5,30: color 4,15: print "INPUT ERROR: NO DATA RECEIVED: PROGRAM ENDING"
		locate 6,30: color 4,15: print "Check Power, Check Serial Cable, Check COM # "
		'write a note to the data file as well...
		write #1, "Program is ending early because no data was received from datalogger. "
		sleep 5000
		goto jump1
	end if

	'make sure there is a complete data string waiting to be read... if not, error out
	if loc(2)<21 then
		locate 7,30: color 4,15: print "INPUT ERROR: INCOMPLETE DATA: PROGRAM ENDING"
		locate 8,30: color 4,15: print "Check Battery or Power Supply to DATALOGGER "
		'write a note to the data file as well...
		write #1, "Program is ending early because of an incomplete data string. "
		sleep 5000
		goto jump1
	end if

	'this is the line that reads the data from serial port buffer
	input #2, mk,seconds,sw,ad1,ad2,ad3,sum

	'perform series of tests to make sure the data string received from picaxe is correct
	'do a test to make sure the checksum is correct, print screen and file error message if not
	'note that program continues to run with either of these error types
		if (sum<>sw+ad1+ad2+ad3) then
			locate 27,10: color 4,15: print "Checksum Data Error in Yellow"
			'draw vertical yellow line to mark region of data error
			line (i,50)-(i,550),14
			'write a note to the data file as well...
			write #1, "Serial Error in Above Data Line"
		end if
	'do a test to make sure the first character of the data string is the character 'X'
	if mk<> "X" then locate 28,10: color 4,15: print "DATA ERROR: First Character received is not X"

	'calculate actual voltage as represented by bit levels
	'note that Analog Digital Converter uses 5.12V reference, so 1 bit is 5 mV
	v1=ad1*.005
	v2=ad2*.005
	v3=ad3*.005

	'calculate temperature as represented by bit levels, results are in degrees F
	'note this calculation depends on B value of the thermistor!
	'circuit: 10K voltage divider with thermistor low (grounded)
	'temperature calculation must be protected from endpoints 0 and 1024

	'protect calculation for data endpoints 0 and 1024 (undefined result)
	if ad1<1 then ad1=1
	if ad2<1 then ad2=1
	if ad3<1 then ad3=1
	if ad1>1023 then ad1=1023
	if ad2>1023 then ad2=1023
	if ad3>1023 then ad3=1023

	t1= (4038/(log(( 10000/(1024/ad1- 1.0))/.01312577))-273.15)*1.8 + 32.0
	t2= (4038/(log(( 10000/(1024/ad2- 1.0))/.01312577))-273.15)*1.8 + 32.0
	t3= (4038/(log(( 10000/(1024/ad3- 1.0))/.01312577))-273.15)*1.8 + 32.0

	if mode="V" then
		'need to divide by 2 to scale 1024 to 512 graph for voltage 
		red1=ad1/2
		blue1=ad2/2
		grn1=ad3/2
	end if

	if mode="T" then
		'need to scale temperature to graph, make this active to plot temperature 
		red1=(t1 + 25) * 2
		blue1=(t2 + 25) * 2
		grn1=(t3 + 25) * 2
	end if

	'red1, blue1 and grn1 are pixel data that must fit inside the 500 pixel high display

	'make sure the end conditions high and low are handled OK (bracketed)
	'this only affects pixels on graph, unabridged data is stored in csv file
	if red1 > 500 then red1 = 500
	if red1 < 0 then red1=0
	if blue1 > 500 then blue1=500
	if blue1 < 0 then blue1=0
	if grn1 > 500 then grn1 = 500
	if grn1 < 0 then grn1=0

	'flip data to plot from the bottom instead of the top
	'not the extra offset of 50 to hit active area of the graph 
	red1=550-red1
	blue1=550-blue1
	grn1=550-grn1

	'print header information at top of the display graph
	'locate 1,2: color 0,15: print "DATALOGGER by Science Bay "
	'locate 1,30: color 0,15: print "Hit ESC key to EXIT "
	if mode="V" then
		locate 2,22: print "          "
		locate 2,22: color 4,15: print using "V1= #.###"; v1
		locate 2,42: print "          "
		locate 2,42: color 1,15: print using "V2= #.###"; v2
		locate 2,62: print "          "
		locate 2,62: color 2,15: print using "V3= #.###"; v3
	end if

	if mode="T" then
		locate 2,22: print "          "
		locate 2,22: color 4,15: print using "T1= ###.#"; t1
		locate 2,42: print "          "
		locate 2,42: color 1,15: print using "T2= ###.#"; t2
		locate 2,62: print "          "
		locate 2,62: color 2,15: print using "T3= ###.#"; t3
	end if

	'calculate time increment in seconds, minutes or hours
	if dur=1 then timeunits=elapsed
	if dur=60 then timeunits=elapsed/60
	if dur=1440 then timeunits=elapsed/3600

	'write command creates comma delimited data files by default
	'actual time, elapsed time, mark, switch, AD1, AD2, AD3
	write #1, time, elapsed, mk, sw, ad1, ad2, ad3, sum, v1, v2, v3, t1, t2, t3

	'skip plotting routine for the first data point
	if i=40 then goto jump3

	'plot the lines on the graph, this creates small error for first data point
	line (i,red1)-(i-1,red2),4
	line (i,blue1)-(i-1,blue2),1
	line (i,grn1)-(i-1,grn2),2

	jump3:
	'save current data as old data for next iteration
	red2 = red1
	blue2 = blue1
	grn2 = grn1

	'draw indicator for switch status, zero or one
	'start by drawing a box for the switch indicator plotting
	line (40,580)-(760,590),7,B
	if sw=0 then line (i,590)-(i,585),4
	if sw=1 then line (i,584)-(i,580),2

	'this is the loop that actually paces the rate of data collection
	'need to update this timing loop based on the chosen duration
	do
		'this check provides an exit point to the user by pressing the ESC key
		if inkey=chr$(27) then goto jump1

		'this segment calculates and prints elapsed time to keep display active
		'calculate elapsed time from start for this set of readings
		elapsed=timer-begin
		if dur=1 then timeunits=elapsed
		if dur=60 then timeunits=elapsed/60
		if dur=1440 then timeunits=elapsed/3600
		'this line for elapsed time is put at the top
		locate 3,30: color 0,15: print using "Elapsed Time: #####.###"; timeunits
		locate 3,60: color 0,15: print xunits

	loop until (timer-begin) > (i-39)*(dur*60/720)

next i

'***********************************************************************************************
'*******************************END OF MAIN DATA ACQUISITION LOOP*******************************
'***********************************************************************************************

sleep 1000

'Jump1 is the exit jump: saves to bitmap, closes inputs and ends the program
jump1:

'save screen page graph as a bitmap with same number identifier as the data file
bsave "BMP" & string(3 - len(str(k)), "0") & k & ".BMP", 0

close #1
close #2

end

'this subroutine provides accurate timing for the data acquisition rate
sub delay(t1 as double)
	dim t2 as double
	t2=timer
	while timer-t2 < t1
	'allow for possibility of seconds clock rolling over at midnight
	if t2>timer then t2=t2-86400
	wend
end sub





